import 'package:firebase_dart/firebase_core.dart';
import 'package:firebase_dart/firebase_dart.dart';
import 'package:jt_firebase/src/api/reference.dart';
import 'package:jt_firebase/src/fireblend/database.dart';
import 'package:meta/meta.dart';

class JtDatabase extends FirebaseDatabase implements FireblendDatabase {
  static RegExp get endWithSlash => RegExp(r"(.*)/$");

  JtDatabase({@required FirebaseApp app, String databaseURL})
      : assert((null != databaseURL || null != app.options.databaseURL),
            '"databaseURL" must be provided on FirebaseApp.configure() or on initializing JtDatabase()!'),
        super(
            app: app,
            databaseURL: (null == databaseURL)
                ? JtDatabase.endWithSlash.hasMatch(app.options.databaseURL)
                    ? app.options.databaseURL
                    : '${app.options.databaseURL}/'
                : JtDatabase.endWithSlash.hasMatch(databaseURL)
                    ? databaseURL
                    : '$databaseURL/');

  @override
  FireblendDatabaseReference ref([String path]) {
    final ref =
        (null == path) ? this.reference() : this.reference().child(path);
    return JtDbReference(ref);
  }

  @override
  Future goOffline() {
    throw Exception('Not implemented!');
  }

  @override
  Future goOnline() {
    throw Exception('Not implemented!');
  }
}
